/* XXX this assumes 1:1 machine:physical memory mapping */
.global vmm_tpa
.proc vmm_tpa
vmm_tpa:
	epc
	;;
	tpa r5=r5
	br.ret.sptk.many b2
	;;
.endp vmm_tpa

.global vmm_set_dfh
.proc vmm_set_dfh:
vmm_set_dfh:
	epc
	;;
	ssm psr.dfh
	/* srlz? */
	br.ret.sptk.many b2
	;;
.endp vmm_set_dfh

/* XXX must check that rgn != 0... but we don't have any spare registers to save pr :( */
.global vmm_write_rr
.proc vmm_write_rr
vmm_write_rr:
	shl r5=r5,61
	epc
	;;
	cmp.ne p63,p0=r5,r0
	;;
(p63)	mov rr[r5]=r6
	/* srlz? */
	br.ret.sptk.many b2
	;;
.endp vmm_write_rr

.global vmm_write_itm
.proc vmm_write_itm
vmm_write_itm:
	epc
	;;
	mov cr.itm=r5
	br.ret.sptk.many b2
	;;
.endp vmm_write_itm
