#ifndef _IDE_DATA_TYPES_H_
#define _IDE_DATA_TYPES_H_
struct ide_data_s{
};

union ide_data{
	struct ide_data_s r;
	uint32_t data;
};

struct ide_error_s{
};

union ide_error{
	struct ide_error_s r;
	uint8_t data;
};

struct ide_feature_s{
};

union ide_feature{
	struct ide_feature_s r;
	uint8_t data;
};

struct ide_sectors_s{
};

union ide_sectors{
	struct ide_sectors_s r;
	uint8_t data;
};

struct ide_lba_low_s{
};

union ide_lba_low{
	struct ide_lba_low_s r;
	uint8_t data;
};

struct ide_lba_mid_s{
};

union ide_lba_mid{
	struct ide_lba_mid_s r;
	uint8_t data;
};

struct ide_lba_hi_s{
};

union ide_lba_hi{
	struct ide_lba_hi_s r;
	uint8_t data;
};

struct ide_dev_s{
	volatile uint8_t sector_hi : 4;
	volatile uint8_t dev : 1;
	volatile uint8_t padding0 : 1;
	volatile uint8_t lba : 1;
};

union ide_dev{
	struct ide_dev_s r;
	uint8_t data;
};

struct ide_command_s{
	volatile uint8_t cmd : 8;
};

union ide_command{
	struct ide_command_s r;
	uint8_t data;
};

struct ide_status_s{
	volatile uint8_t err : 1;
	volatile uint8_t padding0 : 2;
	volatile uint8_t drq : 1;
	volatile uint8_t padding1 : 1;
	volatile uint8_t df : 1;
	volatile uint8_t drdy : 1;
	volatile uint8_t bsy : 1;
};

union ide_status{
	struct ide_status_s r;
	uint8_t data;
};

#endif /* _IDE_DATA_TYPES_H_ */
