enum scsi_io_direction { SCSI_IO_DIR_IN, SCSI_IO_DIR_OUT, SCSI_IO_DIR_NONE };

void *
mpt_setup(bs_seq spaces, dma_handle_t dma, bus_space_t pciconf);

int
mpt_intr(void *device);

int
mpt_scsi_io_request(void *device, uint8_t target_id, uint8_t target_lun, uint8_t *cdb, uint8_t cdb_len,
		    struct scsi_sge *sge, uint32_t sge_count, uint32_t dxfer_len, enum scsi_io_direction direction,
		    callback_t callback, callback_data_t callback_data);
