#define PSR_BE_BIT	1
#define PSR_UP_BIT	2
#define PSR_AC_BIT	3
#define PSR_MFL_BIT	4
#define PSR_MFH_BIT	5
#define PSR_IC_BIT	13
#define PSR_I_BIT	14
#define PSR_PK_BIT	15
#define PSR_DT_BIT	17
#define PSR_DFL_BIT	18
#define PSR_DFH_BIT	19
#define PSR_SP_BIT	20
#define PSR_PP_BIT	21
#define PSR_DI_BIT	22
#define PSR_SI_BIT	23
#define PSR_DB_BIT	24
#define PSR_LP_BIT	25
#define PSR_TB_BIT	26
#define PSR_RT_BIT	27
#define PSR_CPL_BITS	32
#define PSR_IS_BIT	34
#define PSR_MC_BIT	35
#define PSR_IT_BIT	36
#define PSR_ID_BIT	37
#define PSR_DA_BIT	38
#define PSR_DD_BIT	39
#define PSR_SS_BIT	40
#define PSR_RI_BITS	41
#define PSR_ED_BIT	43
#define PSR_BN_BIT	44
#define PSR_IA_BIT	45

#define PSR_BE		(1 << PSR_BE_BIT)
#define PSR_UP		(1 << PSR_UP_BIT)
#define PSR_AC		(1 << PSR_AC_BIT)
#define PSR_MFL		(1 << PSR_MFL_BIT)
#define PSR_MFH		(1 << PSR_MFH_BIT)
#define PSR_IC		(1 << PSR_IC_BIT)
#define PSR_I		(1 << PSR_I_BIT)
#define PSR_PK		(1 << PSR_PK_BIT)
#define PSR_DT		(1 << PSR_DT_BIT)
#define PSR_DFL		(1 << PSR_DFL_BIT)
#define PSR_DFH		(1 << PSR_DFH_BIT)
#define PSR_SP		(1 << PSR_SP_BIT)
#define PSR_PP		(1 << PSR_PP_BIT)
#define PSR_DI		(1 << PSR_DI_BIT)
#define PSR_SI		(1 << PSR_SI_BIT)
#define PSR_DB		(1 << PSR_DB_BIT)
#define PSR_LP		(1 << PSR_LP_BIT)
#define PSR_TB		(1 << PSR_TB_BIT)
#define PSR_RT		(1 << PSR_RT_BIT)
#define PSR_CPL_3	(3 << PSR_CPL_BITS)
#define PSR_IS		(1 << PSR_IS_BIT)
#define PSR_MC		(1 << PSR_MC_BIT)
#define PSR_IT		(1 << PSR_IT_BIT)
#define PSR_ID		(1 << PSR_ID_BIT)
#define PSR_DA		(1 << PSR_DA_BIT)
#define PSR_DD		(1 << PSR_DD_BIT)
#define PSR_SS		(1 << PSR_SS_BIT)
#define PSR_ED		(1 << PSR_ED_BIT)
#define PSR_BN		(1 << PSR_BN_BIT)
#define PSR_IA		(1 << PSR_IA_BIT)

#define PTE_P_BIT	0
#define PTE_MA_BITS	2
#define PTE_A_BIT	5
#define PTE_D_BIT	6
#define PTE_PL_BITS	7
#define PTE_AR_BITS	9
#define PTE_PPN_BITS	12
#define PTE_ED_BIT	52

#define PTE_P		(1 << PTE_P_BIT)
#define PTE_A		(1 << PTE_A_BIT)
#define PTE_D		(1 << PTE_D_BIT)
#define PTE_PL_3	(3 << PTE_PL_BITS)
#define PTE_AR_RW	(2 << PTE_AR_BITS)
#define PTE_AR_RWX	(3 << PTE_AR_BITS)
#define PTE_AR_RX_RWX	(5 << PTE_AR_BITS)
#define PTE_ED		(1 << PTE_ED_BIT)
