#define HCDP_DEV_CONSOLE	0
#define HCDP_DEV_DEBUG		1

struct hcdp_dev
{
    uint8_t	type;
    uint8_t	bits;
    uint8_t	parity;
    uint8_t	stop_bits;
    uint8_t	pci_seg;
    uint8_t	pci_bus;
    uint8_t	pci_dev;
    uint8_t	pci_func;
    uint64_t	baud;
    ACPI_GENERIC_ADDRESS	base_addr;
    uint16_t	pci_dev_id;
    uint16_t	pci_vendor_id;
    uint32_t	global_int;
    uint32_t	clock_rate;
    uint8_t	pci_prog_intfc;
    uint8_t	reserved;
} __attribute__((packed));

struct hcdp_table
{
    ACPI_TABLE_HEADER	header;
    uint32_t		num_entries;
    struct hcdp_dev	hcdp_dev[1];
} __attribute__((packed));
