struct sample {
	uint64_t ip;
	uint32_t mpfn;
	uint32_t wait_time;
	uint8_t type;
	uint8_t pending;
	union {
		struct {
			uint8_t is_write;
			uint8_t access_type;
			uint8_t sent_to;
			uint8_t rcvd_from;
			uint8_t rcvd_data;
			uint8_t spare;
		} fetch;
		struct {
			uint16_t copyset;
		} invalidate;
	};
};

#define NSAMPLES (1024/sizeof(struct sample))
