#ifndef _BFRDRIVER_TYPES_H
#define _BFRDRIVER_TYPES_H


enum bfr_packet_type {PACKET_NONE, 
		  PACKET_IP, 
		  PACKET_UDP, 
		  PACKET_TCP};

typedef struct {
        mem_handle_t handle;
        unsigned long length;
        uintptr_t key;
} buf_t;

typedef struct {
	enum bfr_packet_type type;
        unsigned int c;
        buf_t *v;
} packet_t;

typedef struct {
	unsigned int c;
	packet_t *v;
} pkt_seq;

/* XXX because buf_t is defined above, we define all other buf related types
 * here.
 */

typedef struct {
	unsigned int c;
	buf_t *v;
} buf_seq;


#endif
