/************************************************************************
 * linux-pci.h -- deal with PCI configuration via /proc
 */

typedef struct {
	
	int		fd; /* R/W file descriptor on /proc/bus/pci/BUSID/y.z */
	unsigned	irq;
	unsigned	devfn;
	unsigned short	vendor;
	unsigned short	device;
	unsigned short  subsystem_vendor;
	unsigned short  subsystem_device;
	unsigned int	class;
	
	unsigned int	bus;
	unsigned int	subordinate;
} pci_dev_t;
