/************************************************************************
 * linux_usr_pci.h
 * Common stuff for initialising and using a linux user-level device driver
 */

#ifndef LINUX_USR_PCI_H
#define LINUX_USR_PCI_H

extern int pagesize; /* size of a base page on current platform;
                        initialised by linux_usr_init() */

/*
 * Initialise the driver infrastructure, return a handle to use in
 * the usr_pci_XXX functions
 */
extern int linux_user_user_init(void);

#endif /* ! LINUX_USR_PCI_H */
