.section ".text.gate"
.global gate_page
gate_page:

#if 0
.global vmm_tpa
.proc vmm_tpa
vmm_tpa:
	/* XXX this assumes 1:1 machine:physical memory mapping */
	/* N.B. tpa might fault, see below */
	epc
	;;
	tpa r5=r5
	br.ret.sptk.many b2
	;;
.endp vmm_tpa

.global vmm_tpa_faulted
.proc vmm_tpa_faulted
vmm_tpa_faulted:
	movl r6=1f
	;;
	mov b2=r6
	br.ret.sptk.many b2
	;;
1:
	mov ar.pfs=r7
2:
	break 0x80022
.endp vmm_tpa_faulted
#endif

.org gate_page+0x100
.global vmm_set_dfh
.proc vmm_set_dfh
vmm_set_dfh:
	epc
	;;
	ssm psr.dfh
	/* srlz? */
	br.ret.sptk.many b2
	;;
.endp vmm_set_dfh

/* XXX must check that rgn != 0... but we don't have any spare registers to save pr :( */
.org gate_page+0x200
.global vmm_write_rr
.proc vmm_write_rr
vmm_write_rr:
	shl r5=r5,61
	epc
	;;
	cmp.ne p63,p0=r5,r0
	;;
(p63)	mov rr[r5]=r6
	/* srlz? */
	br.ret.sptk.many b2
	;;
.endp vmm_write_rr

.org gate_page+0x300
.global vmm_write_itm
.proc vmm_write_itm
vmm_write_itm:
	epc
	;;
	mov cr.itm=r5
	br.ret.sptk.many b2
	;;
.endp vmm_write_itm

.org gate_page+0x400
.global vmm_write_itc
.proc vmm_write_itc
vmm_write_itc:
	epc
	;;
	mov ar.itc=r5
	br.ret.sptk.many b2
	;;
.endp vmm_write_itc

.org gate_page+0x500
.global vmm_read_pmd
.proc vmm_read_pmd
vmm_read_pmd:
#ifdef PMU_DIRECT
	epc
	;;
	mov r5=pmd[r5]
#else
	mov r5=r0
#endif
	br.ret.sptk.many b2
	;;
.endp vmm_read_pmd

