#ifndef _IDE_BM_TYPES_H_
#define _IDE_BM_TYPES_H_
struct idebm_command_s{
	volatile uint8_t start_stop : 1;
	volatile uint8_t padding0 : 2;
	volatile uint8_t read_write : 1;
};

union idebm_command{
	struct idebm_command_s r;
	uint8_t data;
};

struct idebm_status_s{
	volatile uint8_t active : 1;
	volatile uint8_t error : 1;
	volatile uint8_t interrupt : 1;
	volatile uint8_t padding0 : 2;
	volatile uint8_t drive_0_cap : 1;
	volatile uint8_t drive_1_cap : 1;
	volatile uint8_t simplex : 1;
};

union idebm_status{
	struct idebm_status_s r;
	uint8_t data;
};

struct idebm_prd_s{
	volatile uint32_t addr : 32;
};

union idebm_prd{
	struct idebm_prd_s r;
	uint32_t data;
};

#endif /* _IDE_BM_TYPES_H_ */
