/************************************************************************
 * debug.h -- debugging macros.
 */

#ifndef DEBUG_H_
#define DEBUG_H_
#include <assert.h>


//#define DEBUG // less serious errors/warnings
#define DEBUG2 // more serious errors/warnings

#ifdef DEBUG
#define DP83820_INTERRUPT
#define PRINT_DEBUG(x) UserPrint x
#else
#define PRINT_DEBUG(x) do { } while(0)
#endif

#ifdef DEBUG2
#define PRINT_DEBUG2(x) UserPrint x
#else
#define PRINT_DEBUG2(x) do { } while(0)
#endif


#endif /* DEBUG_H_ */
