/*
 *        Project:  
 *        Created:  13/03/2003 18:42:20 by Simon Winwood (sjw)
 *  Last Modified:  20/03/2003 17:30:59 by Simon Winwood (sjw)
 *   Version info:  $Revision: 1.2 $ 
 *    Description:
 *
 *       Comments:
 *
 * $Log: lock.h,v $
 * Revision 1.2  2004/08/31 03:02:32  matthewc
 * Works! (pretty much)
 * Still hits PTE_A errors sometimes, and other random small problems.
 *
 * Revision 1.1  2004/03/16 06:03:24  matthewc
 * Add standalone version, now Kenge based.
 *
 * Revision 1.3  2003/03/20 22:39:56  sjw
 * Bugfixes; the driver is now reasonably complete, with thread etc.
 *
 * Revision 1.2  2003/03/20 06:28:46  sjw
 * Added lock implementation.
 *
 * Revision 1.1  2003/03/16 22:12:58  sjw
 * Moved a lot of the mungi-isms out of the code, or have started to.
 * Still needs a bit of work.
 *
 */

#ifndef LOCK_H
#define LOCK_H

typedef int lock_t;

static inline void lock_init(lock_t *lock) 
{
#if 0
    *(volatile lock_t *)lock = 0;
#endif
}

static inline void lock_lock(lock_t *lock) 
{
#if 0
    asm volatile ( "1: mov ar.ccv = r0\n"
		   "mov r8 = 1;;\n"
		   "cmpxchg4.acq r8 = [%1], r8, ar.ccv;;\n"
		   "cmp4.ne p14, p0 = r8, r0\n"
		   "(p14) br.cond.spnt.few 1b" : "=r"(lock) : "r"(lock));
#endif
}
static inline void lock_unlock(lock_t *lock) 
{
#if 0
    *(volatile lock_t *)lock = 0;
#endif
}
#endif /* LOCK_H */
