extern unsigned long stats[];

#define CORE_STATS_INC(var) stats[stat_##var]++
#define CORE_STATS_ADD(var,val) stats[stat_##var]+=(val)
#define CORE_STATS_DEF(var) stat_##var,

#ifndef NSTATS
#define STATS_INC(var) CORE_STATS_INC(var)
#define STATS_ADD(var,val) CORE_STATS_ADD(var,val)
#define STATS_DEF(var) CORE_STATS_DEF(var)
#define STATS_IF(stmt) stmt
#else
#define STATS_INC(var)
#define STATS_ADD(var,val)
#define STATS_DEF(var)
#define STATS_IF(stmt)
#endif

enum {
#include "stats_def.h"
  stat_max
};

#undef STATS_DEF
#undef CORE_STATS_DEF
