/******************************************************************************
 *
 * Name: acnetvm.h - OS specific defines, etc.
 *
 *****************************************************************************/

#ifndef __ACNETVM_H__
#define __ACNETVM_H__

#define ACPI_OS_NAME			"NetVM"
/* #define ACPI_USE_STANDARD_HEADERS */
/* #define ACPI_USE_SYSTEM_CLIBRARY */

#ifdef __ia64__
# define ACPI_MACHINE_WIDTH		64
# define COMPILER_DEPENDENT_INT64	long
# define COMPILER_DEPENDENT_UINT64	unsigned long
# define ACPI_FLUSH_CPU_CACHE()		/* nothing */
#else
# error Need architecture-specific defines here
#endif

#include "acgcc.h"

#endif /* __ACNETVM_H__ */
