/*
 @LICENSE@
*/

#include <assert.h>
#ifndef LIBC_NO_L4
#include <l4.h>
#include <l4e.h>
#endif

void
__assert(const char *msg, int line, const char *file)
{
#ifndef LIBC_NO_L4
	l4e_printf("\n\nassertion failed: %s, line %d in %s\n\n", msg,
		   (int) line, file);

	L4_KDB_Enter("assertion failed");
#endif
}
