#ifndef _ASSERT_H
#define _ASSERT_H

#define assert(cond) do {\
        if (!(cond)) {\
		char msg[256]; \
		sprintf(msg, "assertion failed at %s:%d\n",\
			__FILE__, __LINE__);\
		printk("%s", msg); \
		panic(msg); \
	}\
    } while (0)
#endif

