#include "asm/unistd.h"
#include <sys/mman.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <stdint.h>
#include <assert.h>
#include <sys/io.h> /* iopl() */
#include "error.h"



int pagesize;

inline int
usr_pci_open(int bus, int slot, int fn) 
{
	return syscall(__NR_usr_pci_open, bus, slot, fn);
}


int
linux_usr_init(int bus, int slot, int function)
{
	int dma;
	if ((dma = usr_pci_open(bus, slot, function))  < 0)
		return -1;

	if (iopl(3))
		syserror("iopl(): can't set privilege to access IO space");

	pagesize = sysconf(_SC_PAGE_SIZE);

	printf("DMA IS %d\n", dma);
	return dma;
}

