#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
#include <string.h>
#include "setrealtime.h"

int set_realtime_priority(void )
{
        struct sched_param schp;
        /*
	 * set the process to realtime privs
	 */
        memset(&schp, 0, sizeof(schp));
	schp.sched_priority = sched_get_priority_max(SCHED_FIFO) - 1;
	if (sched_setscheduler(0, SCHED_FIFO, &schp) != 0) {
		perror("sched_setscheduler");
	        exit(1);
	}
	return 0;
}

