#define src0	r16
#define src1	r17
#define dst0	r18
#define dst1	r19
#define cnt	r20
#define saved_lc	r21
#define saved_pr	r22

	// N.B. src/dst must be 8 byte aligned
	// count must be a multiple of 128 bytes
	.global copy_area
copy_area:
	alloc r8=ar.pfs,3,8-3,0,8
	mov saved_lc=ar.lc
	shr cnt=in2,7
	;;
	add cnt=-1,cnt
	mov saved_pr=pr
	;;
	mov ar.lc=cnt
	mov src0=in0
	mov dst0=in1
	;;
.prefetch:
	lfetch.fault [src0], 128
	lfetch.fault.excl [dst0], 128
	br.cloop.dptk.few .prefetch
	;;
	mov dst0=in0
	shr cnt=in2,5
	add dst1=8,in0
	;;
	mov src0=in1
	mov ar.ec=2
	add src1=8,in1
	cmp.eq p16,p17=r0,r0
	add cnt=-1,cnt
	;;
	mov ar.lc=cnt
1:
(p16)	ld8	r34=[src0],16
(p16)	ld8	r38=[src1],16
(p17)	st8	[dst0]=r33,16
(p17)	st8	[dst1]=r37,16
        ;;
(p16)	ld8	r32=[src0],16
(p16)	ld8	r36=[src1],16
(p16)	st8	[dst0]=r34,16
(p16)	st8	[dst1]=r38,16
	br.ctop.dptk.few 1b
	;;
	mov ar.lc=saved_lc
	mov pr=saved_pr,-1
	br.ret.sptk.many b0
	;;

