#include "vm.h"
#include "profile_tlb.h"

unsigned long start_time;
struct sample *sample_buffer;
unsigned int sample;

void
profile_tlb(unsigned long ip, unsigned long va, unsigned int rr, unsigned char type)
{
	struct sample *s;

	if (!sample_buffer)
		sample_buffer = malloc(NSAMPLES*sizeof(struct sample));

	s = &sample_buffer[sample++];
	s->ip = ip;
	s->va = va; 
	s->rr = rr;
	s->type = type;
	if (sample == NSAMPLES)
	{
		struct request request;
		request.type = IPC_PROFILE;
		request.profile.start = start_time;
		start_time = request.profile.end = read_itc();
		ipc_send_page(62, &request, (unsigned long)sample_buffer, NSAMPLES*sizeof(struct sample), DATA_AREA_MALLOC);
		sample_buffer = NULL;
		sample = 0;
	}
}

